<?php

class log_model extends CI_Model {
	private $logs;

	function __construct()
	{
		// Call the Model constructor
		parent::__construct();
		$this->logs = array();
	}


	// Log Functions
	function get_logs()
	{
		$this->get_prove_client_log();
		$this->get_php_log();
		$this->get_web_log();
		$this->get_web_access_log();
		return $this->logs;
	}


	function get_prove_client_log($lines = 0)
	{
		$this->load->model('config_model');
		$log_pathes = array(
			$this->config_model->config['prove_client.out'],
			'/tmp/prove_client.out',
			'/tmp/prove_client.log',
			'/prove/prove_clent.out',
			'/prove/prove_clent.log',
			);
		$this->logs['prove_client_log_file'] = $this->config_model->config['prove_client.out'];
		foreach($log_pathes as $path) {
			if (@is_file($path)) {
				$this->logs['prove_client_log_file'] = $path;
				break;
			}
		}
		$this->logs['prove_client_log'] = $this->_get_log($this->logs['prove_client_log_file']); 

		return $this->logs;
	}


	function get_php_log($lines = 40)
	{
		$this->load->model('config_model');
		$log_pathes = array(
			$this->config_model->config['php.error'],
			'/tmp/php_error.log',
			'/prove/php_error.log',
			'/var/log/php_error.log',
			'/usr/local/php/logs/php_error.log',
			'/usr/local/php5.3/logs/php_error.log',
			);
		$this->logs['php_error_log_file'] = $this->config_model->config['php.error'];
		foreach($log_pathes as $path) {
			if (@is_file($path)) {
				$this->logs['php_error_log_file'] = $path;
				break;
			}
		}
		$this->logs['php_error_log'] = $this->_get_log($this->logs['php_error_log_file']); 

		return $this->logs;
	}


	function get_web_log($lines = 40)
	{
		return $this->get_apache_log($lines);
	}


	function get_web_access_log($lines = 40)
	{
		return $this->get_apache_access_log($lines);
	}


	private function get_apache_log($lines)
	{
		$this->load->model('config_model');
		$log_pathes = array(
			$this->config_model->config['web.error'],
			'/tmp/apache_error.log',
			'/prove/apache_error.log',
			'/var/log/httpd/error_log',
			'/usr/local/apache2/logs/error_log',
			'/usr/local/apache2.0/logs/error_log',
			);
		$this->logs['web_error_log_file'] = $this->config_model->config['web.error'];
		foreach($log_pathes as $path) {
			if (@is_file($path)) {
				$this->logs['web_error_log_file'] = $path;
				break;
			}
		}
		$this->logs['web_error_log'] = $this->_get_log($this->logs['web_error_log_file']);

		return $this->log;
	}


	private function get_apache_access_log($lines)
	{
		$this->load->model('config_model');
		$log_pathes = array(
			$this->config_model->config['web.access'],
			'/tmp/apache_access.log',
			'/prove/apache_access.log',
			'/var/log/httpd/access_log',
			'/usr/local/apache/logs/access_log',
			'/usr/local/apache2/logs/access_log',
			'/usr/local/apache2.0/logs/access_log',
			);
		$this->logs['web_access_log_file'] = $this->config_model->config['web.access'];
		foreach($log_pathes as $path) {
			if (@is_file($path)) {
				$this->logs['web_access_log_file'] = $path;
				break;
			}
		}
		$this->logs['web_access_log'] = $this->_get_log($this->logs['web_access_log_file']);

		return $this->log;
	}


	private function _get_log($file, $lines = 40)
	{
		if (!@filesize($file)) {
			return 'File is empty or does not exists.'; // Log cannot contains multibyte chars
		}
		return shell_exec('LANG=C LC_ALL=C tail -n '.escapeshellarg($lines).' '.escapeshellarg($file));
	}
}
