<?php

class prove_log_model extends CI_Model {

	function __construct()
	{
		// Call the Model constructor
		parent::__construct();
	}

	///////////////////////////////////////////////////////////////////////////////////
	// Get prove logs for jqGrid
	function get_prove_logs($page, $limit, $sort_index, $sort_order)
	{
		return $this->get_logs($page, $limit, $sort_index, $sort_order);
	}

	function get_prove_log($id)
	{
		return prove_log_meta($id);
	}


	///////////////////////////////////////////////////////////////////////////////////
	// Log management
	function create_log($meta)
	{
		$ret = prove_log_create($meta);
		return $ret;
	}


	function edit_log($meta)
	{
		if (empty($meta['id'])) {
			// Error. ID is mandatory
			return false;
		}
		if (empty($meta['locked'])) {
			$meta['locked'] = false;
		}
		if (!prove_log_meta($meta['id'], $meta)) {
			return false;
		}
		$ret = prove_log_meta($meta['id']);
		return $ret;
	}


	function remove_log($id)
	{
		$meta = prove_log_meta($id);
		if ($meta) {
			$ret = prove_log_remove($id);
			if ($ret) {
				return (object)$meta;
			}
		}
		return false;
	}


	function prepare_trace($id)
	{
		return prove_log_prepare(PROVE_LOG_TRACE, $id);
	}


	function prepare_validate($id)
	{
		if (!prove_log_prepare(PROVE_LOG_VALIDATE, $id)) {
			return false;
		}
		// Lock Log
		prove_log_lock(prove_log_id(PROVE_LOG_VALIDATE), true);
		// Ignore lock failure
		return true;
	}


	function prepare_diff($id)
	{
		return prove_log_prepare(PROVE_LOG_DIFF, $id);
	}

	function save_log($type)
	{
		// Lock log
		prove_log_lock(prove_log_id($type), true);
		// Save log
		if (!prove_log_save($type)) {
			return false;
		}
		return true;
	}


	///////////////////////////////////////////////////////////////////////////////////
	// Private methods
	private function get_logs($page, $limit, $sort_index, $sort_order)
	{
		if ($page < 0) {
			$page = 1;
		}
		if (!$limit) {
			$limit = 100;
		}
		$offset = ($page-1) * $limit;
		$ids = prove_log_ids();

		if (!$ids) {
			// Return empty result
			$log->page = $page;
			$log->total = 0;
			$log->records = 0;
			$log->cell = 'cell';
			$log->rows = array();
			return $log;
		}

		// Sort by id
		krsort($ids);

		$numlogs = count($ids);

		// Remove unneeded elements for paging
		$ids = array_slice($ids, $offset, $limit, true);

		$log->page = $page;
		$log->total = ceil($numlogs/$limit);
		$log->records = $numlogs;
		$log->cell = 'cell';
		foreach($ids as $id => $meta) {
			//var_dump('<pre>',$tmp, $id, $dir, prove_request($id, $dir, PROVE_OUTPUT));
			$obj = (object)$meta;
			$log->rows[] = $obj;
		}
		return $log;
	}


}
