<?php

class prove_model extends CI_Model {

	function __construct()
	{
		// Call the Model constructor
		parent::__construct();
	}


	function mode($mode = NULL)
	{
		if ($mode) {
			return prove_mode($mode);
		}
		return prove_mode();
	}


	// get PHP source
	function get_php_source($file)
	{
		if (!ENABLE_DOWNLOAD) {
			return 'Download is disabled by confiugration.';
		}
		if (!file_exists($file)) {
			return PHP_EOL.'File does not exist. ('.$file.')'.PHP_EOL;
		}
		$ret = file($file);
		if (!$ret) {
			return PHP_EOL.'Cannot access file('.$file.')'.PHP_EOL;
		}
		return $ret;
	}

	// get PHP source
	function get_file($file)
	{
		if (!ENABLE_DOWNLOAD) {
			return 'Download is disabled by confiugration.';
		}
		if (!file_exists($file)) {
			return PHP_EOL.'File does not exist. ('.$file.')'.PHP_EOL;
		}
		$ret = file_get_contents($file);
		if (!$ret) {
			return PHP_EOL.'Cannot access file('.$file.')'.PHP_EOL;
		}
		return $ret;
	}



	///////////////////////////////////////////////////////////////////////////////////
	// Get trace logs for jqGrid
	function get_trace_requests($page, $limit, $sort_index, $sort_order)
	{
		return $this->get_requests($page, $limit, $sort_index, $sort_order, TRACE_DIR);
	}


	// Get trace logs nums
	function get_trace_num_logs()
	{
		return prove_log_count(prove_log_id(PROVE_LOG_TRACE));
	}


	// Get a trace log
	function get_trace_request($request_id)
	{
		return $this->get_request($request_id, TRACE_DIR);
	}


	// Get a trace log output
	function get_trace_request_output($request_id) {
		return $this->get_request_output($request_id, TRACE_DIR);
	}


	// Get output trace with UNIX trace command
	function get_trace_output_text($id)
	{
		$ret = $this->get_request_text($id, TRACE_DIR, PROVE_OUTPUT);
		if (!$ret['trace']) {
			$ret['trace'] = '(empty)';
		}
		// remove unneeded quotes
		$ret['output'] = substr($ret['output'], 1, strlen($ret)-2);
		$info = prove_request($id, TRACE_DIR);
		$ret['script'] = $info['request']['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get prove log trace with UNIX trace command
	function get_trace_internal_text($id, $use_var_export)
	{
		$ret = $this->get_request_text($id, TRACE_DIR, PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL, $use_var_export);
		if (!$ret['trace']) {
			$ret['trace'] = '(empty)';
		}
		$info = prove_request($id, TRACE_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get prove log trace of array 
	function get_trace_internal_array($id)
	{
		$ret = $this->get_trace_array($id, PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL);
		$info = prove_request($id, TRACE_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	///////////////////////////////////////////////////////////////////////////////////
	// Get validate logs for jqGrid
	function get_validate_requests($page, $limit, $sort_index, $sort_order) 
	{
		return $this->get_requests($page, $limit, $sort_index, $sort_order, VALIDATE_DIR);
	}


	// Get validate logs nums
	function get_validate_num_logs()
	{
		return prove_log_count(prove_log_id(PROVE_LOG_VALIDATE));
	}


	// Get a validate log
	function get_validate_request($request_id)
	{
		return $this->get_request($request_id, VALIDATE_DIR);
	}


	// Get a validate log output
	function get_validate_request_output($request_id) {
		return $this->get_request_output($request_id, VALIDATE_DIR);
	}


	// Get output validate with UNIX validate command
	function get_validate_output_text($id)
	{
		$ret = $this->get_request_text($id, VALIDATE_DIR, PROVE_OUTPUT);
		if (!$ret['validate']) {
			$ret['validate'] = '(empty)';
		}
		// remove unneeded quotes
		$ret['output'] = substr($ret['output'], 1, strlen($ret)-2);
		$info = prove_request($id, VALIDATE_DIR);
		$ret['script'] = $info['request']['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get prove log validate with UNIX validate command
	function get_validate_internal_text($id, $use_var_export)
	{
		$ret = $this->get_request_text($id, VALIDATE_DIR, PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL, $use_var_export);
		if (!$ret['validate']) {
			$ret['validate'] = '(empty)';
		}
		$info = prove_request($id, VALIDATE_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get prove log validate of array 
	function get_validate_internal_array($id)
	{
		$ret = $this->get_validate_array($id, PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL);
		$info = prove_request($id, VALIDATE_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	///////////////////////////////////////////////////////////////////////////////////
	// Get diff logs for jqGrid
	function get_diff_requests($page, $limit, $sort_index, $sort_order)
	{
		return $this->get_requests($page, $limit, $sort_index, $sort_order, DIFF_DIR);
	}


	// Get diff logs nums
	function get_diff_num_logs()
	{
		return prove_log_count(prove_log_id(PROVE_LOG_DIFF));
	}


	// Get a diff log
	function get_diff_request($request_id)
	{
		return $this->get_request($request_id, DIFF_DIR);
	}


	// Get a diff log output
	function get_diff_request_output($request_id)
	{
		return $this->get_request_output($request_id, DIFF_DIR);
	}


	// Get output diff with UNIX diff command
	function get_diff_output_text($id, $use_var_export)
	{
		$ret = $this->get_diff_text($id,PROVE_OUTPUT, $use_var_export, true, false);
		if (!$ret['diff']) {
			$ret['diff'] = '(empty)';
		}
		$info = prove_request($id, DIFF_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get prove log diff with UNIX diff command
	function get_diff_internal_text($id, $use_var_export)
	{
		$ret = $this->get_diff_text($id, PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL, $use_var_export);
		if (!$ret['diff']) {
			$ret['diff'] = '(empty)';
		}
		$info = prove_request($id, DIFF_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get prove log diff of array
	function get_diff_internal_array($id)
	{
		$ret = $this->get_diff_array($id, PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL);
		$info = prove_request($id, DIFF_DIR, PROVE_REQUEST);
		$ret['script'] = $info['_SERVER']['SCRIPT_FILENAME'];
		return $ret;
	}


	// Get diff source - validate
	function get_diff_internal_text_src_validate($id, $use_var_export, $output=false)
	{
		if ($output) {
			$flag = PROVE_OUTPUT;
		} else {
			$flag = PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL;
		}
		$use_var_export = (int)$use_var_export;
		$file = '/tmp/prove-'.$id.'-'.$flag.'-'.$use_var_export.'-validate.txt';
		if (!file_exists($file)) {
			return PHP_EOL.'File does not exist. ('.$file.')'.PHP_EOL;
		}
		$data = file_get_contents($file);
		if ($data) {
			return $data;
		} else {
			return '(empty)';
		}
	}


	// Get diff source - diff
	function get_diff_internal_text_src_diff($id, $use_var_export, $output=false)
	{
		if ($output) {
			$flag = PROVE_OUTPUT;
		} else {
			$flag = PROVE_REQUEST|PROVE_SESSION|PROVE_FCALL;
		}
		$use_var_export = (int)$use_var_export;
		$file = '/tmp/prove-'.$id.'-'.$flag.'-'.$use_var_export.'-diff.txt';
		if (!file_exists($file)) {
			return PHP_EOL.'File does not exist. ('.$file.')'.PHP_EOL;
		}
		return file_get_contents($file);
	}


	////////// private functions //////////
	private function get_request_text($id, $dir, $flag, $use_var_export=false, $unlink=false)
	{
		if (strspn($id, '0123456789.-') != strlen($id)) {
			return array('id'=>'Invalid Request ID ('.$id.')', 'output'=>null);
		}
		$path = '/tmp/prove-'.$id.'-output.txt';
		$log = prove_request($id, $dir, $flag);
		$use_var_export = (int)$use_var_export;
		if ($use_var_export) {
			$out = var_export($log, true);
		} else {
			$fcall = $log['function_call'];
			$i = 0;
			foreach($fcall as $c) {
				$log['function_call'][$i++] = serialize($c);
			}
			$out = var_export($log, true);
		}

		if ($unlink) {
			@unlink($path);
		}

		return array('id'=>$id,
					 'output'=>$out,
			);
	}


	private function get_diff_text($id, $flag, $use_var_export=false, $output=false, $unlink=false)
	{
		$max_bytes = DIFF_MAX_BYTES;

		if (strspn($id, '0123456789.-') != strlen($id)) {
			return array('diff'=>'Invalid Request ID ('.$id.')',
						 'diff_out'=>null,
						 'valid_file'=>null,
						 'valid_text'=>null,
						 'diff_file'=>null,
						 'diff_text'=>null);
		}
		$use_var_export = (int)$use_var_export;
		// FIXME: Static tmp dir
		$diff_out = '/tmp/prove-'.$id.'-'.$flag.'-'.$use_var_export.'-out.txt';
		$old_file = '/tmp/prove-'.$id.'-'.$flag.'-'.$use_var_export.'-validate.txt';
		$old = prove_request($id, VALIDATE_DIR, $flag);
		$new_file = '/tmp/prove-'.$id.'-'.$flag.'-'.$use_var_export.'-diff.txt';
		$new = prove_request($id, DIFF_DIR, $flag);
		if ($use_var_export) {
			$old_text = var_export($old, true);
			$new_text = var_export($new, true);
			//file_put_contents($old_file, var_export($old, true));
			//file_put_contents($new_file, var_export($new, true));
		} else {
			$fcall = $old['function_call'];
			$i = 0;
			foreach($fcall as $c) {
				$old['function_call'][$i++] = serialize($c);
			}
			$old_text = var_export($old, true);

			$fcall = $new['function_call'];
			$i = 0;
			foreach($fcall as $c) {
				$new['function_call'][$i++] = serialize($c);
			}
			$new_text = var_export($new, true);
		}

		if ($output) {
			// remove unneeded quotes
			$old_text = substr($old_text, 1, strlen($old_text)-2);
			$new_text = substr($new_text, 1, strlen($new_text)-2);
		}
		file_put_contents($old_file, $old_text);
		file_put_contents($new_file, $new_text);
		$diff = shell_exec("LANG=C LC_ALL=C diff -U 8 $old_file $new_file");
		file_put_contents($diff_out, $diff);
		if ($unlink) {
			unlink($diff_out);
			unlink($old_file);
			unlink($new_file);
		}

		//var_dump($diff,$o,$old,$n,$new); die();
		return array('diff'=>substr($diff,0,$max_bytes),
					 'diff_out'=>$diff_out,
					 'valid_file'=>$old_file,
					 'valid_text'=>substr($old_text,0,$max_bytes),
					 'diff_file'=>$new_file,
					 'diff_text'=>substr($new_text,0,$max_bytes),
			);
	}

// Array Diff Example
// $valid  = array('a'=>12, 'b'=>34, 'd'=>56, 'v'=>0 'x'=>1, 'y'=>2, 'z'=>3);
// $target = array('a'=>12, 'b'=>34, 'c'=>56, 'x'=>1, 'y'=>2, 'z'=>9);
/* Output should be as follows
// arrayRecursiveDiff($valid, $target);
======== differ or only in $valid ===============
array(3) {
  ["d"]=>
  int(56)
  ["w"]=>
  int(0)
  ["z"]=>
  int(3)
}
// arrayRecursiveDiff($target, $valid);
======== differ or only in $target ==============
array(2) {
  ["c"]=>
  int(56)
  ["z"]=>
  int(9)
}
======== UNIX diff validation source as old data =========
--- /tmp/prove7UsI4Y	2011-03-24 13:05:11.000000000 +0900
+++ /tmp/proveVkeGNI	2011-03-24 13:05:11.000000000 +0900
@@ -1,9 +1,8 @@
 array (
   'a' => 12,
   'b' => 34,
-  'd' => 56,
-  'w' => 0,
+  'c' => 56,
   'x' => 1,
   'y' => 2,
-  'z' => 3,
+  'z' => 9,
 )

*/
	private function arrayRecursiveDiff($aArray1, $aArray2)
	{
		$aReturn = array();
		foreach ($aArray1 as $mKey => $mValue) {
			if (array_key_exists($mKey, $aArray2)) {
				if (is_array($mValue)) {
				$aRecursiveDiff = $this->arrayRecursiveDiff($mValue, $aArray2[$mKey]);
				if (count($aRecursiveDiff)) { $aReturn[$mKey] = $aRecursiveDiff; }
				} else {
					if ($mValue != $aArray2[$mKey]) {
						$aReturn[$mKey] = $mValue;
					}
				}
			} else {
				$aReturn[$mKey] = $mValue;
			}
		}
		return $aReturn;
	}


	private function get_diff_array($id, $flag, $use_var_export=true, $unlink=false)
	{
		if (strspn($id, '0123456789.-') != strlen($id)) {
			return array('valid'=>'Invalid ID:'.$id,
						 'diff'=>'Invalid ID:'.$id);
		}
		$old = prove_request($id, VALIDATE_DIR, $flag);
		$new = prove_request($id, DIFF_DIR, $flag);
		if (!is_array($old) && !is_array($new)) {
			return array('Error'=>'Cannot load log');
		}

		$valid = $this->arrayRecursiveDiff($old, $new);
		$diff = $this->arrayRecursiveDiff($new, $old);
		return array(
			'valid' => $valid,
			'diff' => $diff,
			);
	}


	public function get_num_requests($dir)
	{
		/* FIXME: Using meta file directly */
		return (int)file_get_contents($dir.DIRECTORY_SEPARATOR.'_COUNT');
	}


	private function get_requests($page, $limit, $sort_index, $sort_order, $dir)
	{
		if ($page < 0) {
			$page = 1;
		}
		if (!$limit) {
			$limit = 100;
		}
		$offset = ($page-1) * $limit;
		$ids = prove_request_ids($dir, $offset, $limit);

		$numlogs = $this->get_num_requests($dir);

		$log = new StdClass;
		$log->page = $page;
		$log->total = ceil($numlogs/$limit);
		$log->records = $numlogs;
		$log->cell = 'cell';
		foreach($ids as $id) {
			$tmp = prove_request($id, $dir, PROVE_REQUEST);
			//var_dump('<pre>',$tmp, $id, $dir, prove_request($id, $dir, PROVE_OUTPUT));
			$obj = new StdClass;
			$obj->id = $tmp['x_prove_id'];
			$obj->request_method = $tmp['request_method'];
			$obj->output_size = strlen(prove_request($id, $dir, PROVE_OUTPUT));
			$obj->request_uri = $tmp['request_uri'];
			$obj->path_translated = $tmp['path_translated'];
			$log->rows[] = $obj;
		}
		return $log;
	}


	private function get_request($request_id, $dir)
	{
		if (!$request_id)
			return null;
		$log = prove_request($request_id, $dir, PROVE_REQUEST|PROVE_OUTPUT|PROVE_SESSION);
		$finfo = new finfo(FILEINFO_MIME);
		if (empty($log['output'])) {
			$log['output_mime'] = 'Null';
		} else {
			$mime = $finfo->buffer(prove_request($request_id, $dir, PROVE_OUTPUT));
			$log['output_mime'] = $mime ? $mime : 'Unkown';
		}
		array_walk_recursive($log,
							function(&$val, $key) {
								$val = base64_encode(htmlentities($val,ENT_QUOTES, 'ISO-8859-1'));
							}
			);
		return $log;
	}


	private function get_request_output($request_id, $dir)
	{
		if (!$request_id)
			return null;
		$log = prove_request($request_id, $dir, PROVE_OUTPUT);
		return $log;
	}
}